-module(cmd_util).

-export([exec/2]).

%% Borrowed from https://stackoverflow.com/questions/27028486/how-to-execute-system-command-in-erlang-and-get-results-unreliable-oscmd-1

exec(Command, Env) ->
    Port = open_port({spawn, Command},
                     [
                      {env, Env},
                      stream,
                      in,
                      eof,
                      hide,
                      exit_status]),
    get_data(Port, []).

get_data(Port, Sofar) ->
    receive
        {Port, {data, Bytes}} ->
            get_data(Port, [Sofar | Bytes]);
        {Port, eof} ->
            Port ! {self(), close},
            receive {Port, closed} -> true end,
            receive
                {'EXIT', Port, _} -> ok
                after 1 ->              % force context switch
                          ok
            end,
            ExitCode = receive
                           {Port, {exit_status, Code}} -> Code
                       end,
            {ExitCode, lists:flatten(Sofar)}
    end.

